Declare Sub makeCHRcache(ByVal tilenum As UInteger)
Dim Shared map1reg(3), map1bitpos, map1accum As UByte
Dim Shared map9latch As UByte

Type map4struct
  cmd As UByte
  vromsize As UByte
  prgaddr As UByte
  chraddrselect As UInteger
  irqcounter As UInteger
  irqlatch As UInteger
  irqenable As UByte
  swp As UByte
  prgswitch1 As UInteger
  prgswitch2 As UInteger
End Type
Dim Shared map4 As map4struct

Sub SwapPRG(ByVal banknum As UInteger, ByVal newchunk As UInteger, ByVal banksize As UInteger)
	Dim tmpbank As UInteger
	newchunk = (newchunk * banksize)
	For tmpbank = ((banknum*banksize) Shr 10) To ((banknum*banksize) Shr 10) + (banksize Shr 10) - 1
		prgbank(tmpbank) = newchunk
		newchunk = newchunk + 1024
	Next tmpbank
End Sub

Sub SwapCHR(ByVal banknum As UInteger, ByVal newchunk As UInteger, ByVal banksize As UInteger)
	Dim tmpbank As UInteger
	If ROM.chrcount = 0 Then Exit Sub
	newchunk = newchunk * banksize
	For tmpbank = ((banknum*banksize) Shr 10) To ((banknum*banksize) Shr 10) + (banksize Shr 10) - 1
		chrbank(tmpbank) = newchunk
		newchunk = newchunk + 1024
		'For mkchr = 0 To (banksize Shr 4)
		'	makeCHRcache((tmpbank Shl 6)+mkchr)
		'Next mkchr
	Next tmpbank
End Sub

#Macro map1calc()
	Select Case As Const (map1reg(0) And 3)
		Case 0
			ntmap(0) = &h2000
			ntmap(1) = &h2000
			ntmap(2) = &h2000
			ntmap(3) = &h2000
		Case 1
			ntmap(0) = &h2400
			ntmap(1) = &h2400
			ntmap(2) = &h2400
			ntmap(3) = &h2400
		Case 2
			ntmap(0) = &h2000
			ntmap(1) = &h2400
			ntmap(2) = &h2000
			ntmap(3) = &h2400
		Case 3
			ntmap(0) = &h2000
			ntmap(1) = &h2000
			ntmap(2) = &h2400
			ntmap(3) = &h2400
	End Select
	If (map1reg(0) And 8) Then
		If (map1reg(0) And 4) Then
			SwapPRG(0, map1reg(3) And &hF, 16384)
			SwapPRG(1, (ROM.prgcount\16)-1, 16384)
		Else
			SwapPRG(0, 0, 16384)
			SwapPRG(1, map1reg(3) And &hF, 16384)
		End If
	Else
		SwapPRG(0, (map1reg(3) And &hF) Shr 1, 32768)
	End If
	If (map1reg(0) And 16) Then
		SwapCHR(0, map1reg(1), 4096)
		SwapCHR(1, map1reg(2), 4096)
	Else
		SwapCHR(0, map1reg(1) Shr 1, 8192)
	End If
#EndMacro

Sub mapperwrite(ByVal addr As UInteger, ByVal value As UInteger)
	Select Case As Const ROM.mapper
		Case 1 'MMC1
			If addr >= &h8000 Then
				If (value And 128) = 128 Then
					map1reg(0) = (map1reg(0) And &hF3)+&hC
					map1bitpos = 0: map1accum = 0
					Exit Sub
				End If
				map1accum = map1accum Or ((value And 1) Shl map1bitpos)
				If map1bitpos = 4 Then
					If (addr >= &hE000) Then
						map1reg(3) = map1accum
					ElseIf (addr >= &hC000) Then
						map1reg(2) = map1accum
					ElseIf (addr >= &hA000) Then
						map1reg(1) = map1accum
					Else
						map1reg(0) = map1accum
					End If
					map1calc()
					map1bitpos = 0: map1accum = 0
					Exit Sub
				End If
				map1bitpos = (map1bitpos + 1) Mod 5
			End If
		Case 2
			If addr >= &h8000 Then SwapPRG(0, value, 16384)
		Case 4 'MMC3
			Select Case addr
				Case &h8000
					map4.cmd = value And 7
					if ((value Shr 6) And 1) Then map4.prgaddr = 2 Else map4.prgaddr = 0
					if (value Shr 7) Then map4.chraddrselect = &h1000 Else map4.chraddrselect = 0
				Case &h8001
					Select Case map4.cmd
						Case 0
							SwapCHR(map4.chraddrselect Shr 10, value, 1024)
							SwapCHR(((1 Shl 10) Xor map4.chraddrselect) Shr 10, value+1, 1024)
						Case 1
							SwapCHR(((2 Shl 10) Xor map4.chraddrselect) Shr 10, value, 1024)
							SwapCHR(((3 Shl 10) Xor map4.chraddrselect) Shr 10, value+1, 1024)
						Case 2
							SwapCHR(((4 Shl 10) Xor map4.chraddrselect) Shr 10, value, 1024)
						Case 3
							SwapCHR(((5 Shl 10) Xor map4.chraddrselect) Shr 10, value, 1024)
						Case 4
							SwapCHR(((6 Shl 10) Xor map4.chraddrselect) Shr 10, value, 1024)
						Case 5
							SwapCHR(((7 Shl 10) Xor map4.chraddrselect) Shr 10, value, 1024)
						Case 6
							SwapPRG(0+map4.prgaddr, value, 8192)
						Case 7
							SwapPRG(1+map4.prgaddr, value, 8192)
					End Select
				Case &hA000
					ROM.mirroring = value And 1
					Select Case ROM.mirroring
						Case 0
							ntmap(0) = &h2000
							ntmap(1) = &h2000
							ntmap(2) = &h2400
							ntmap(3) = &h2400
						Case 1
							ntmap(0) = &h2000
							ntmap(1) = &h2400
							ntmap(2) = &h2000
							ntmap(3) = &h2400
					End Select
				Case &hC000
					map4.irqcounter = value
				Case &hC001
					map4.irqlatch = value
				case &hE000
					map4.irqenable = 0
					map4.irqcounter = map4.irqlatch
				case &hE001
					map4.irqenable = 1
			End Select
		Case 7 'AOROM
			Select Case addr
				Case Is >= &h8000
					SwapPRG(0, value And 15, 32768)
			End Select
		Case 9 'MMC2
			Select Case addr
				Case &hA000 To &hAFFF
					SwapPRG(0, value, 8192)
				Case &hB000 To &hCFFF
					SwapCHR(0, value, 4096)
				Case &hD000 To &hDFFF
					If map9latch = &hFD Then
						SwapCHR(1, value, 4096)
					End If
				Case &hE000 To &hEFFF
					If map9latch = &hFE Then
						SwapCHR(1, value, 4096)
					End If
				Case &hF000 To &hFFFF
					ROM.mirroring = value And 1
			End Select
	End Select
End Sub

#Macro SetupMapper()
	For n = 0 To 7
		chrbank(n) = n*1024
	Next n
	Select Case As Const ROM.mapper
		Case 0, 2
			SwapPRG(0, 0, 16384)
			SwapPRG(1, (ROM.prgcount \ 16)-1, 16384)
		Case 1
			Write6502(&h8000, 128)
			SwapPRG(0, 0, 16384)
			SwapPRG(1, (ROM.prgcount \ 16)-1, 16384)
		Case 4 'MMC3
         SwapPRG(0, 0, 16384)
         SwapPRG(1, (ROM.prgcount\16)-1, 16384)
         map4.irqenable = 0: map4.irqcounter = 0: map4.irqlatch = 0
         PPUdata.bgtable = 0: PPUdata.sprtable = &h1000
		Case 7 'Nina-1
			SwapPRG(0, 0, 32768)
			SwapCHR(0, 0, 8192)
		Case 9 'MMC2
			SwapPRG(0, 0, 8192)
			SwapPRG(1, (ROM.prgcount\8)-3, 8192)
			SwapPRG(2, (ROM.prgcount\8)-2, 8192)
			SwapPRG(3, (ROM.prgcount\8)-1, 8192)
			map9latch = &hFE
	End Select
#EndMacro
