Function PPUread(ByVal addr As UInteger) As UByte
	Static PPUbuffer As UByte
	addr = addr And &h3FFF
	If (addr >= &h3F00) Then addr = (addr And &h1F) + &h3F00
	If (addr > &h2FFF) And (addr < &h3F00) Then addr = (addr And &hEFF) + &h3000
	If (addr = &h3F04) Or (addr = &h3F08) Or _
		(addr = &h3F0C) Or (addr = &h3F14) Or (addr = &h3F18) Then addr = &h3F00
	If addr = &h3F10 Then addr = &h3F00
	Select Case addr
		Case &hFD0 To &hFDF, &h1FD0 To &h1FDF
			map9latch = &hFD
		Case &hFE0 To &hFEF, &h1FE0 To &h1FEF
			map9latch = &hFE
	End Select
	If (ROM.chrcount > 0) And (addr < &h2000) Then
'	If addr < &h2000 Then
		PPUread = CHRMEM(CHRbank(addr Shr 10) + (addr Mod 1024))
	Else
		If addr < &h3F00 Then
			PPUread = PPUbuffer
			PPUbuffer = VRAM(addr)
		Else
			PPUread = VRAM(addr)
		End If
	End If
End Function

Sub makeCHRcache(ByVal tilenum As UInteger)
  for ty = 0 To 7
    for tx = 0 To 7
  offsetloc = (tilenum Shl 4) + ty
  Select Case As Const tx
    case 0:
         if (PPUread(offsetloc) And 128) Then tmppixel = 1 Else tmppixel = 0
         if (PPUread(offsetloc+8) And 128) Then tmppixel = tmppixel + 2
  	case 1:
         if (PPUread(offsetloc) And 64) Then tmppixel = 1 else tmppixel = 0
         if (PPUread(offsetloc+8) And 64) Then tmppixel = tmppixel + 2
  	case 2:
         if (PPUread(offsetloc) And 32) Then tmppixel = 1 else tmppixel = 0
         if (PPUread(offsetloc+8) And 32) Then tmppixel = tmppixel + 2
  	case 3:
         if (PPUread(offsetloc) And 16) Then tmppixel = 1 else tmppixel = 0
         if (PPUread(offsetloc+8) and 16) Then tmppixel = tmppixel + 2
  	case 4:
         if (PPUread(offsetloc) And 8) Then tmppixel = 1 else tmppixel = 0
         if (PPUread(offsetloc+8) And 8) Then tmppixel = tmppixel + 2
  	case 5:
         if (PPUread(offsetloc) And 4) Then tmppixel = 1 else tmppixel = 0
         if (PPUread(offsetloc+8) And 4) Then tmppixel = tmppixel + 2
  	case 6:
         if (PPUread(offsetloc) And 2) Then tmppixel = 1 else tmppixel = 0
         if (PPUread(offsetloc+8) And 2) Then tmppixel = tmppixel + 2
  	case 7:
         if (PPUread(offsetloc) And 1) Then tmppixel = 1 else tmppixel = 0
         if (PPUread(offsetloc+8) And 1) Then tmppixel = tmppixel + 2
  End Select
      CHRcache(tilenum, tx, ty) = tmppixel
    Next tx
  Next ty
End Sub

Sub PPUwrite(ByVal addr As UInteger, ByVal value As UByte)
	addr = addr And &h3FFF
	If (addr >= &h3F00) Then addr = (addr And &h1F) + &h3F00
	If (addr > &h2FFF) And (addr < &h3F00) Then addr = (addr And &hEFF) + &h3000
	If addr = &h3F10 Then addr = &h3F00
	Select Case addr
		Case Is < &h2000
			If ROM.chrcount = 0 Then
				CHRMEM(CHRbank(addr Shr 10) + (addr Mod 1024)) = value
				'makeCHRcache(addr Shr 4)
			End If
		Case &h2000 To &h23FF: addr = (addr - &h2000) + ntmap(0)
		Case &h2400 To &h27FF: addr = (addr - &h2400) + ntmap(1)
		Case &h2800 To &h2BFF: addr = (addr - &h2800) + ntmap(2)
		Case &h2C00 To &h2FFF: addr = (addr - &h2C00) + ntmap(3)
		Case &h3F00: VRAM(&h3F10) = value
		Case &h3F10: VRAM(&h3F00) = value
		Case &hFD0 To &hFDF, &h1FD0 To &h1FDF
			map9latch = &hFD
		Case &hFE0 To &hFEF, &h1FE0 To &h1FEF
			map9latch = &hFE
	End Select
	VRAM(addr) = value
End Sub

Function PPUreadreg(ByVal addr As UInteger) As UByte
	addr = addr And 7
	Select Case As Const addr
		Case 2
			PPUreadreg = PPU.vblank*128 + PPU.spr0hit*64 + PPU.sprcount*32 + (PPUregs(2) And &h1F)
			PPU.vblank = 0
			PPU.latch = 0
			PPU.scrolllatch = 0
		Case 4
			PPUreadreg = spriteRAM(spriteaddr)
			'If PPU.vblank = 0 Then spriteaddr = spriteaddr + 1
		Case 7
			PPUreadreg = PPUread(VRAMaddr)
			VRAMaddr = (VRAMaddr + PPU.addrinc) Mod 16384
		Case Else
			PPUreadreg = PPUregs(addr)
	End Select
End Function

Sub PPUwritereg(ByVal addr As UInteger, ByVal value As UInteger)
	addr = addr And 7
	PPUregs(addr) = value
	Select Case As Const addr
		Case 0
			PPU.nmivblank = value Shr 7
			If (value And 32) = 32 Then PPU.sprsize = 16 Else PPU.sprsize = 8
			PPU.bgtable = ((value Shr 4) And 1) * &h1000
			PPU.sprtable = ((value Shr 3) And 1) * &h1000
			If (value And 4) = 4 Then PPU.addrinc = 32 Else PPU.addrinc = 1
			PPU.nametable = value And 3
		Case 1
			PPU.sprvisible = (value Shr 4) And 1
			PPU.bgvisible = (value Shr 3) And 1
			PPU.sprclip = (value Shr 2) And 1
			PPU.bgclip = (value Shr 1) And 1
		Case 3
			spriteaddr = value
		Case 4
			spriteRAM(spriteaddr) = value
			spriteaddr = (spriteaddr + 1) Mod 256
		Case 5
			If PPU.latch = 0 Then
				PPU.hscroll = value
				PPU.latch = 1
			Else
				PPU.vscroll = value
				PPU.latch = 0
			End If
		Case 6
			If PPU.latch = 0 Then
				VRAMaddr = (VRAMaddr And &hFF) Or (value Shl 8)
				PPU.latch = 1
			Else
				VRAMaddr = (VRAMaddr And &hFF00) Or value
				PPU.latch = 0
			End If
		Case 7
			PPUwrite(VRAMaddr, value)
			VRAMaddr = (VRAMaddr + PPU.addrinc) Mod 16384
	End Select
End Sub

#Macro drawsprites(sl)
	sl = sl - 1
	If PPU.sprclip Then st = 8 Else st = 0
	sprnum = 0
	For idx = 63 To 0 Step -1
		tmpidx = idx Shl 2
		spry = spritebuffer(tmpidx)
		sprtile = spritebuffer(tmpidx+1)
		sprpal = spritebuffer(tmpidx+2) And 3
		sprpri = (spritebuffer(tmpidx+2) Shr 5) And 1
		sprflipx = (spritebuffer(tmpidx+2) Shr 6) And 1
		sprflipy = spritebuffer(tmpidx+2) Shr 7
		sprx = spritebuffer(tmpidx+3)
		If PPU.sprsize = 16 Then
			dosprite = 2
			sprtile = sprtile And &hFE
			If sprflipy Then sprtile = sprtile + 1
		Else
			dosprite = 1
		End If
			While dosprite
				If (sl >= spry) And (sl <= (spry+7)) Then
					If sl < 239 Then sprnum = sprnum + 1
					If sprnum > 8 Then PPU.sprcount = 1: Exit For
					boundxr = sprx + 7
					liney = sl - spry
					If sprflipy Then liney = 7 - liney
					plotx = boundxr
					For xval = sprx To boundxr
						patternoffset = PPU.sprtable + (sprtile Shl 4) + liney
						usebank = patternoffset Shr 10
						usebankmod = patternoffset Mod 1024
						tmpx = xval - sprx
						pixel = (CHRMEM(chrbank(usebank) + usebankmod) Shr (7 - tmpx)) And 1
						pixel = pixel + (((CHRMEM(chrbank(usebank) + usebankmod+8) Shr (7 - tmpx)) And 1) Shl 1)
						If pixel > 0 Then
							coloraddr = &h10 + pixel + (sprpal Shl 2)
							If sprflipx = 0 Then plotx = xval
							If plotx >= st Then
							   If (coloraddr = &h14) Or (coloraddr = &h18) Then pixel = &h0
								If pri = 1 Then sprback(plotx) = VRAM(&h3F00 + coloraddr) Else sprfront(plotx) = VRAM(&h3F00 + coloraddr)
								If idx = 0 Then PPU.spr0hit = 1
							End If
						End If
						plotx = plotx - 1
					Next xval
				End If
				dosprite = dosprite - 1: spry = spry + 8
				If sprflipy Then sprtile = sprtile - 1 Else sprtile = sprtile + 1
			Wend
	Next idx
	sl = sl + 1
#EndMacro

Dim bitposit, tmpcalcx As UByte
Dim pixel, pixel2, calcx, calcy, temp1, temp2, usent, ntaddr, ntval, ntmapptr, attribx, attriby, attribbyte, VRAMptr As UInteger

#Macro drawbackground(dry, drx)
	VRAMptr = @VRAM(0)
	ntmapptr = @ntmap(0)
	calcx = drx: calcy = dry
	Select Case As Const PPU.nametable
		Case 1: 'calcx = dx + 256: calcy = dy
			Asm
				mov eax, [calcx]
				Add eax, 256
				mov [calcx], eax
			End Asm
		Case 2: 'calcx = dx: calcy = dy + 240
			Asm
				mov eax, [calcy]
				Add eax, 240
				mov [calcy], eax
			End Asm
		Case 3: 'calcx = dx + 256: calcy = dy + 240
			Asm
				mov eax, [calcx]
				Add eax, 256
				mov [calcx], eax
				mov eax, [calcy]
				Add eax, 240
				mov [calcy], eax
			End Asm
	End Select
	temp1 = PPU.hscroll
	temp2 = PPU.vscroll
	Asm
		mov eax, [calcx]
		Add eax, [temp1]
		And eax, 511
		mov [calcx], eax
		mov eax, [calcy]
		Add eax, [temp2]
		mov ebx, 480
		Xor edx, edx
		div eax, ebx
		mov [calcy], edx
	'End Asm

   	'this code replaces: usent = (calcx Shr 8) + (calcy Shr 8)*2
		'mov eax, [calcx]
		'Shr eax, 8
		'mov ebx, [calcy]
		'Shr ebx, 8
		'Shl ebx, 1
		'Or eax, ebx
		'mov [usent], eax
	End Asm
	If (calcx < 256) And (calcy < 240) Then
		usent = 0
	ElseIf (calcx > 255) And (calcy < 240) Then
		usent = 1
	ElseIf (calcx < 256) And (calcy > 239) Then
		usent = 2
	ElseIf (calcx > 255) And (calcy > 239) Then
		usent = 3
	End If
	Asm
'		Shl ebx, 3
'		mov eax, [calcy]
'		Sub eax, ebx
'		mov [calcy], eax

      'this code replaces:
   	'calcx = calcx Mod 256
	   'calcy = calcy Mod 240
		mov eax, [calcx]
		And eax, 255
		mov [calcx], eax
		mov eax, [calcy]
		mov ebx, 240
		Xor edx, edx
		div eax, ebx
		mov [calcy], edx
		
		'this code replaces: tmpcalcx = calcx Mod 8
		mov eax, [calcx]
		And eax, 7
		mov [tmpcalcx], eax
		
		'this code replaces: ntaddr = ntmap(usent)
		mov ebx, [ntmapptr]
		mov esi, [usent]
		shl esi, 2
		mov eax, [ebx+esi]
		mov [ntaddr], eax

	  'this code replaces: ntval = VRAM(ntaddr + ((calcy And 248) Shl 2) + (calcx Shr 3))
		mov eax, [calcy]
		And eax, 248
		Shl eax, 2
		mov ebx, [calcx]
		Shr ebx, 3
		Add eax, ebx
		Add eax, [ntaddr]
		mov [temp1], eax
	End Asm
	ntval = VRAM(temp1)
	
	'this code replaces: patternoffset = PPU.bgtable + (ntval Shl 4) + (calcy Mod 8)
	temp1 = PPU.bgtable
	Asm
		mov eax, [ntval]
		Shl eax, 4
		mov ebx, [calcy]
		And ebx, 7
		add eax, ebx
		Add eax, [temp1]
	'patternoffset = chrbank(patternoffset Shr 10) + (patternoffset Mod 1024)
		mov ebx, 1024
		Xor edx, edx
		div eax, ebx
		mov [temp1], eax
		mov [temp2], edx
	End Asm
	
	'this code replaces: pixel = (CHRMEM(patternoffset) Shr (7 - tmpcalcx)) And 1
	patternoffset = chrbank(temp1) + temp2
	pixel = CHRMEM(patternoffset)
	Asm
		mov al, 7
		Sub al, [tmpcalcx]
		mov [bitposit], al
		mov eax, [pixel]
		mov cl, [bitposit]
		Shr eax, cl
		And eax, 1
		mov [pixel], eax
		'patternoffset = patternoffset + 8
		mov eax, [patternoffset]
		Add eax, 8
		mov [patternoffset], eax
	End Asm
	
	'this replaces: pixel = pixel + (((CHRMEM(patternoffset) Shr (7 - tmpcalcx)) And 1) Shl 1)
	pixel2 = CHRMEM(patternoffset)
	Asm
		mov eax, [pixel2]
		mov cl, [bitposit]
		Shr eax, cl
		And eax, 1
		Shl eax, 1
		mov ebx, [pixel]
		Or eax, ebx
		mov [pixel], eax

		'this replaces: attribx = calcx Shr 5: attriby = calcy Shr 5
			mov eax, [calcx]
			Shr eax, 5
			mov [attribx], eax
			mov eax, [calcy]
			Shr eax, 5
			mov [attriby], eax

		'this replaces: attribbyte = VRAM(ntaddr + &h3C0 + (attriby Shl 3) + attribx)
			mov esi, [attriby]
			Shl esi, 3
			Add esi, [attribx]
			Add esi, &h3C0
			Add esi, [ntaddr]
			mov ebx, [VRAMptr]
			mov eax, [ebx+esi]
			mov [attribbyte], eax
	End Asm
	
		attribbyte = attribbyte Shr (((calcx And 16) Shr 3) Or ((calcy And 16) Shr 2)) And 3
	'this next part was to replace the above line, but it doesnt work for some reason
	'	Asm
	'		mov ecx, [calcx]
	'		And ecx, 16
	'		Shr ecx, 3
	'		mov edx, [calcy]
	'		And edx, 16
	'		Shr edx, 2
	'		Or ecx, edx
	'		And ecx, 3
	'		mov eax, [attribbyte]
	'		Shr eax, cl
	'		Shl eax, 2
	'		Add eax, [pixel]
	'		Add eax, &h3F00
	'		mov [pixel], eax
		'End Asm
		pixel = pixel + (attribbyte Shl 2)
  If (pixel = &h4) Or (pixel = &h8) Or (pixel = &hC) Then pixel = &h0
	backgnd(drx) = VRAM(&h3F00 + pixel)
#EndMacro

Sub TextDraw(ByVal xtext As UInteger, ByVal ytext As UInteger, textdata As String)
	For textpos = 1 To Len(textdata)
		cc = Asc(Mid$(textdata, textpos, 1))
		For dry = 0 To 7
			For drx = 0 To 7
				outputNES((ytext Shl 3)+dry, (xtext Shl 3)+drx) = font((cc Shl 6)+(dry Shl 3)+drx)+64
			Next drx
		Next dry
		xtext = xtext + 1
		If xtext = 32 Then xtext = 0: ytext = ytext + 1
	Next textpos
End Sub
